#ifdef __USAGE      /* hotkey.c */
%C &
#endif

#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <sys/types.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <limits.h>
#include <unistd.h>
#include <process.h>
#include <sys/console.h>
#include <sys/con_msg.h>
#include <sys/kernel.h>

int     debug = 0;
int     dump;
char    dev[200];
char    line[200];
struct  _console_ctrl *cc;
int     fd, console;
union   _console_msg {
    struct _console_hotkey          hotkey;
    struct _console_hotkey_reply    hotkey_reply;
    } msg;

main( int argc, char *argv[] )
    {
    char *printer;

    if ( argc > 1 )
        debug = 1;

    if ( ( fd = open( "/dev/con1", O_RDWR ) ) == -1 ) {
        fprintf( stderr, "Hotkey: Unable to open '/dev/con1'\n" );
        exit( EXIT_FAILURE );
        }

    if ( !( cc = console_open( fd, O_RDWR ) ) ) {
        fprintf( stderr, "Hotkey: Unable to open console channel to '/dev/con1'\n" );
        exit( EXIT_FAILURE );
        }
    close( fd );

    console = cc->console;  /* Console number so we talk to the right guy */

    for( ;; ) {
        if ( debug )
            printf( "TOF\n" );

        /*
         * inform console task that we wish to process hotkeys
         */
        msg.hotkey.type = _CONSOLE_HOTKEY;
        msg.hotkey.handle = cc->handle;
        msg.hotkey.console = console;

        if ( Send( cc->driver, &msg, &msg, 
                sizeof( msg.hotkey ), sizeof( msg.hotkey_reply ) ) == -1 ) {
            fprintf( stderr, "Hotkey: Error on console channel\n" );
            exit( EXIT_FAILURE );
            }
        if ( msg.hotkey_reply.status != 0 ) {
            fprintf( stderr, "Hotkey: error return\n" );
            exit( EXIT_FAILURE );
            }
        if ( debug )
            printf( "key = %d\n", msg.hotkey_reply.key );

        switch( msg.hotkey_reply.key ) {
            case 0:     /* CTRL-ALT-Prtsc   */
                printer = getenv("PRTSC");
                if(printer == NULL)
                    printer = "/dev/par";
                sprintf( line, "Prtsc </dev/con%d >%s &",
                    msg.hotkey_reply.console, printer);
                if( debug )
                    printf("Hotkey [%s]\n", line );
                else
                    system( line );
/*
                sprintf( dev, "/dev/con%d", msg.hotkey_reply.console );
                if ( spawnl( P_NOWAIT, "/usr/bin/prtsc", "prtsc", dev, "/dev/par", NULL ) == -1 )
                    perror( "Hotkey" );
 */
                break;
                
            case 1:     /* CTRL-ALT-F1      */
            case 2:     /* CTRL-ALT-F2      */
            case 3:     /* CTRL-ALT-F3      */
            case 4:     /* CTRL-ALT-F4      */
            case 5:     /* CTRL-ALT-F5      */
            case 6:     /* CTRL-ALT-F6      */
            case 7:     /* CTRL-ALT-F7      */
            case 8:     /* CTRL-ALT-F8      */
            case 9:     /* CTRL-ALT-F9      */
            case 10:    /* CTRL-ALT-F10     */
            default:    /* Huh?             */
                fprintf( stderr, "Hotkey: Unknown hotkey (0x%02x) pressed\r\l", msg.hotkey_reply.key );
                break;
            }
        }
    }
